// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{Dock, DockOverlayEdge};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockOverlay")]
    pub struct DockOverlay(Object<ffi::DzlDockOverlay, ffi::DzlDockOverlayClass>) @extends gtk::EventBox, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable, Dock;

    match fn {
        type_ => || ffi::dzl_dock_overlay_get_type(),
    }
}

impl DockOverlay {
    pub const NONE: Option<&'static DockOverlay> = None;

    #[doc(alias = "dzl_dock_overlay_new")]
    pub fn new() -> DockOverlay {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_dock_overlay_new()).unsafe_cast() }
    }
}

impl Default for DockOverlay {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::DockOverlay>> Sealed for T {}
}

pub trait DockOverlayExt: IsA<DockOverlay> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_dock_overlay_get_edge")]
    #[doc(alias = "get_edge")]
    fn edge(&self, position: gtk::PositionType) -> Option<DockOverlayEdge> {
        unsafe {
            from_glib_none(ffi::dzl_dock_overlay_get_edge(
                self.as_ref().to_glib_none().0,
                position.into_glib(),
            ))
        }
    }

    #[doc(alias = "dzl_dock_overlay_get_edge_adjustment")]
    #[doc(alias = "get_edge_adjustment")]
    fn edge_adjustment(&self, position: gtk::PositionType) -> Option<gtk::Adjustment> {
        unsafe {
            from_glib_none(ffi::dzl_dock_overlay_get_edge_adjustment(
                self.as_ref().to_glib_none().0,
                position.into_glib(),
            ))
        }
    }

    #[doc(alias = "hide-edges")]
    fn connect_hide_edges<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn hide_edges_trampoline<P: IsA<DockOverlay>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDockOverlay,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockOverlay::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"hide-edges\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    hide_edges_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_hide_edges(&self) {
        self.emit_by_name::<()>("hide-edges", &[]);
    }
}

impl<O: IsA<DockOverlay>> DockOverlayExt for O {}

impl fmt::Display for DockOverlay {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockOverlay")
    }
}
